local addon, shared = ...

local RX = _Rattus
RX.GADGET = {}
local RG = RX.GADGET
RG.ACTIVESETS = {}
RG.ACTIVEACHVT= {}
RG.BUILDSET = {}

if Inspect.Addon.Detail("Gadgets") ~= nil then

local SZLABEL = UI.CreateFrame("Text", "SZLABEL", WT.Context)
SZLABEL:SetVisible(false)
SZLABEL:SetText("qqQQ")

local ht14 = 0
local ht12 = 0
local ht10 = 0

function RG.Create(configuration)
	local rframe = UI.CreateFrame("Frame", WT.UniqueName("RATTUS"), WT.Context)
	
	rframe.DATA = { setlist={}, config=configuration }
	rframe:SetBackgroundColor(0,0,0,0.2)

	rframe:SetVisible(false)
	rframe:SetLayer(1)

	rframe.label = UI.CreateFrame("Text", "rframe.label", rframe)
	rframe.label:SetFontSize(14)
	rframe.label:SetFontColor(1,1,1,1)
	rframe.label:SetText("Set: "..configuration.selSet)
	rframe.label:SetPoint("TOPLEFT", rframe, "TOPLEFT", 2,2)
	rframe.label:SetLayer(2)
	
	rframe:SetWidth(120)
	rframe:SetHeight(24)

	for k,v in pairs(Rattus_Settings.saved[configuration.selSet]) do
		table.insert(rframe.DATA.setlist, {a=k, t=v})
	end
	table.sort(rframe.DATA.setlist, function(a,b) return a.t < b.t end)
	
	RG.ACTIVESETS[configuration.selSet] = true
	table.insert(RG.BUILDSET, {s=configuration.selSet, f=rframe})
	
	return rframe
end

function RG.ConfigDialog(container)
	local allsets = {}
	for k,v in pairs(Rattus_Settings.saved) do
		if RG.ACTIVESETS[k] == nil then
			table.insert(allsets, { text=k, value = l })
		end
	end
	
	table.sort(allsets, function(a,b) return a.text < b.text end)

	dialog = WT.Dialog(container)
		:Label("RATTUS TRACKER")
		:Combobox("selSet", "Selected Set:", allsets[1].text,
			allsets, false)
end

function RG.GetConfiguration()
	return dialog:GetValues()
end

function RG.SetConfiguration(config)
	dialog:SetValues(config)
end

WT.Gadget.RegisterFactory("RATTUS Display",
{
	name="RATTUS Display",
	description="Displays a RATTUS Achievement Set",
	author="Adelea@Icewatch-EU",
	version=addon.toc.Version,
	iconTexAddon=addon.identifier,
	iconTexFile="textures/mm_button.png",
	["Create"] = RG.Create,
	["ConfigDialog"] = RG.ConfigDialog,
	["GetConfiguration"] = RG.GetConfiguration, 
	["SetConfiguration"] = RG.SetConfiguration, 
})

function RG.HandleUpdate(a, f)
	if RX.achv.all[a].complete == true then
		local c_oldHt = f.achv[a].c.totHt
		local f_oldHt = f.totHt
		local hDiff = 0
		
		f.achv[a].l:SetFontColor(0,1,0)
		
		for k,v in pairs(f.achv[a].r) do
			v.d:SetVisible(false)
			v.p:SetVisible(false)
		end

		f.achv[a].c.totHt = ht12
		hDiff = c_oldHt - ht12
		f.totHt = f.totHt - hDiff
		
		f.achv[a].c:SetHeight(ht12)
		f:SetHeight(f.totHt)
	else
		for rk, rd in pairs(RX.achv.all[a].requirement) do
			if rd.complete == true then
				f.achv[a].r[rk].d:SetFontColor(0,1,0)
				f.achv[a].r[rk].p:SetText("")
			else
				f.achv[a].r[rk].p:SetText(string.format("%d/%d", rd.countDone or 0, rd.count or 1))
			end
		end
	end
end

function RG.BuildTracker(f)
	if ht12 == 0 then
		SZLABEL:SetFontSize(12)
		ht12 = SZLABEL:GetHeight()
		SZLABEL:SetFontSize(10)
		ht10 = SZLABEL:GetHeight()
		ht14 = f.label:GetHeight()
	end

	f:SetVisible(true)
	f.totHt = ht14 + 4
	f.achv = {}
	for k,v in pairs(f.DATA.setlist) do
		if RG.ACTIVEACHVT[v.a] == nil then
			RG.ACTIVEACHVT[v.a] = {}
		end
		table.insert(RG.ACTIVEACHVT[v.a], f)
		local c = UI.CreateFrame("Frame", "c", f)
		c:SetLayer(5)
		if k==1 then
			c:SetPoint("TOPLEFT", f.label, "BOTTOMLEFT", 0,0)
		else
			c:SetPoint("TOPLEFT", f.achv[f.DATA.setlist[k-1].a].c, "BOTTOMLEFT", 0,0)
		end
		local i = UI.CreateFrame("Texture", "i", f)
		i:SetLayer(10)
		i:SetTexture("Rift", RX.achv.all[v.a].icon)
		i:SetHeight(ht12)
		i:SetWidth(ht12)
		i:SetPoint("TOPLEFT", c, "TOPLEFT", 0,0)
		local l = UI.CreateFrame("Text", "l", f)
		l:SetFontSize(12)
		l:SetText(RX.achv.all[v.a].name)
		l:SetPoint("CENTERLEFT", i, "CENTERRIGHT", 2, 0)
		l:SetLayer(10)
		
		local r = {}
		
		if RX.achv.all[v.a].complete == true then
			c.totHt = ht12
			c:SetHeight(c.totHt)
			f.totHt = f.totHt + ht12
			l:SetFontColor(0,1,0)
		else
			for rk, rd in pairs(RX.achv.all[v.a].requirement) do
				local d = UI.CreateFrame("Text", "d", f)
				d:SetFontSize(10)
				d:SetLayer(10)
				d:SetText(rd.name)
				if rk == 1 then
					d:SetPoint("TOPLEFT", i, "BOTTOMLEFT", 0,0)
				else
					d:SetPoint("TOPLEFT", r[rk-1].d, "BOTTOMLEFT", 0,0)
				end
				local p = UI.CreateFrame("Text", "p", f)
				p:SetLayer(10)
				p:SetFontSize(10)
				p:SetPoint("CENTERRIGHT", d, "CENTERLEFT", (ht12*16), 0)
				
				r[rk] = {d=d, p=p}
				
				if rd.complete == true then
					d:SetFontColor(0,1,0)
					p:SetText("")
				else
					d:SetFontColor(1,1,1)
					p:SetText(string.format("%d/%d", rd.countDone or 0, rd.count or 1))
				end
			end
			c.totHt = ht12 + (ht10 * #RX.achv.all[v.a].requirement)
			c:SetHeight(c.totHt)
			f.totHt = f.totHt + c.totHt
		end
		c:SetWidth(ht12 * 16)
		f.achv[v.a] = {c=c, i=i, l=l, r=r}
	end
	f:SetHeight(f.totHt)
	f:SetWidth(4 + (ht12 * 16))
end

function RG.Event_System_Update_Begin()
	if #RG.BUILDSET > 0 then
		local allFound = false
		for x=#RG.BUILDSET, 1, -1 do
			allFound = true
			local setname = RG.BUILDSET[x].s
			for k,v in ipairs(RG.BUILDSET[x].f.DATA.setlist) do
				if RX.achv.all[v.a] == nil then
					allFound = false
				end
			end
			if allFound then
				RG.BuildTracker(RG.BUILDSET[x].f)
				table.remove(RG.BUILDSET, x)
			end
		end
	end
end

Command.Event.Attach(Event.System.Update.Begin, RG.Event_System_Update_Begin, "Event.System.Update.Begin")
	
end